SystemOrganization addCategory: #DaliotsLinearAlgebra!

!Number methodsFor: '*DaliotsLinearAlgebra' stamp: 'HwaJong 8/29/2013 18:26'!
addToPolynomial: aPolynomial 

	^Polynomial coefficient: (aPolynomial coefficient copy modifyLast: [:that| that + self ])! !

!Number methodsFor: '*DaliotsLinearAlgebra' stamp: 'HwaJong 8/29/2013 19:17'!
magnitude
	^self abs! !

!Number methodsFor: '*DaliotsLinearAlgebra' stamp: 'HwaJong 8/29/2013 18:23'!
multiplyByPolynomial: aPolynomial 

	^Polynomial coefficient: (aPolynomial coefficient * self)! !

!Number methodsFor: '*DaliotsLinearAlgebra' stamp: 'HwaJong 8/29/2013 15:47'!
subtractFromPolynomial: aPolynomial 

	^aPolynomial coefficient: (aPolynomial coefficient copy modifyLast: [:that| that-self ])! !

!SequenceableCollection methodsFor: '*DaliotsLinearAlgebra' stamp: 'HwaJong 8/29/2013 18:17'!
accumulate: anArray from: anIndex

	"Dolphin: self replaceFrom: anIndex size: (anArray size) with: ((self copyFrom: anIndex size: anArray size) + anArray)"
	self replaceFrom: anIndex to: (anArray size + anIndex - 1) with: ((self copyFrom: anIndex size: anArray size) + anArray) startingAt: 1! !

!SequenceableCollection methodsFor: '*DaliotsLinearAlgebra' stamp: 'HwaJong 8/29/2013 18:19'!
copyFrom: anInteger size: anInteger2 
	^self copyFrom: anInteger to: (anInteger + anInteger2 - 1)! !

!SequenceableCollection methodsFor: '*DaliotsLinearAlgebra' stamp: 'HwaJong 8/29/2013 15:36'!
modifyLast: aBlockClosure 
	self at: self size modify: aBlockClosure ! !

Object subclass: #Polynomial
	instanceVariableNames: 'coefficientVector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DaliotsLinearAlgebra'!

!Polynomial class methodsFor: 'instance creation' stamp: 'HwaJong 8/29/2013 15:30'!
coefficient: aSequencableCollection

	^self new coefficient: aSequencableCollection; yourself.! !

!Polynomial class methodsFor: 'instance creation' stamp: 'HwaJong 8/29/2013 17:02'!
order: anInteger 
	
"anInteger is the order of the new polynomial instance"
	^self coefficient: (Array new: anInteger+1 withAll: 0)! !

!Polynomial class methodsFor: 'instance creation' stamp: 'HwaJong 8/29/2013 18:21'!
root: aNumber

	^Polynomial coefficient: (Array with:1 with: (aNumber negated))! !

!Polynomial class methodsFor: 'instance creation' stamp: 'HwaJong 8/29/2013 18:20'!
roots: aCollection

	|productOfPolynomials|
	productOfPolynomials := Polynomial coefficient: #(1).

	aCollection do: [:root| productOfPolynomials := (self root: root) * productOfPolynomials ].
	^productOfPolynomials! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 16:59'!
* polynomialOrNumber

	^polynomialOrNumber multiplyByPolynomial: self! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 18:24'!
+ numberOrPolynomial

	^numberOrPolynomial addToPolynomial: self! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 15:38'!
- numberOrPolynnomial

	^numberOrPolynnomial subtractFromPolynomial: self! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 15:43'!
= aPolynomial

	^self coefficient = aPolynomial coefficient! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 15:46'!
adaptToNumber: aNumber andSend: aSymbol 
	^(Polynomial coefficient: {aNumber}) perform: aSymbol with: self! !

!Polynomial methodsFor: 'changing' stamp: 'HwaJong 8/29/2013 15:35'!
addToInteger: anInteger 

	^self coefficient: (self coefficient copy modifyLast: [:that| that + anInteger ])! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 18:25'!
addToPolynomial: aPolynomial

	| maxOrder |
	maxOrder := self order max: aPolynomial order.
	^Polynomial coefficient:
		((self order: maxOrder) coefficient + (aPolynomial order: maxOrder) coefficient)! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 15:35'!
coefficient

	^coefficientVector! !

!Polynomial methodsFor: 'changing' stamp: 'HwaJong 8/29/2013 15:32'!
coefficient: aSequenceableCollection

	coefficientVector := aSequenceableCollection.! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 19:12'!
derivatived
	
	|newCoefficientVector|
	newCoefficientVector := Array new: self order.
	newCoefficientVector keysAndValuesDo: [:indx :coef | newCoefficientVector at: indx put: ( coefficientVector size - indx) * (coefficientVector at: indx) ].

	^self class coefficient: newCoefficientVector.! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 19:14'!
highestCoefficient

	^self coefficient first! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 18:29'!
laguerresRoots

	^RootsOfPolynomialAlgorithm new
		polynomial: self;
		oneRootAlgorithm: (LaguerreAlgorithm new iterationLimit: 100);
		reset;
		runUntil;
		roots! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 17:00'!
multiplyByPolynomial: aPolynomial

	|answerPolynomial|
	answerPolynomial := Polynomial order: self order + aPolynomial order. 

	aPolynomial coefficient keysAndValuesDo: [:indx :value| answerPolynomial coefficient accumulate: (self coefficient * value) from: indx].
	^answerPolynomial! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 15:40'!
order

	^coefficientVector size - 1! !

!Polynomial methodsFor: 'changing' stamp: 'HwaJong 8/29/2013 15:42'!
order: anInteger

	(anInteger > self order)
		ifTrue: [^Polynomial coefficient: ((Array new: (anInteger - self order) withAll: 0), coefficientVector) ].
	(anInteger = self order)
		ifTrue: [^self].
	(anInteger < self order)
		ifTrue: [^Polynomial coefficient: (coefficientVector copyFrom: coefficientVector size-anInteger) ].
! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 19:13'!
quo: aPolynomial

	^(self quoAndRem: aPolynomial) first! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 19:14'!
quoAndRem: aPolynomial

	|quo rem|
	quo := Array new: self order-aPolynomial order+1 withAll: 0.
	rem := self coefficient copy.

	1 to: quo size do:
	[ :i| |p|
		p := (rem at:i) / (aPolynomial highestCoefficient).
		quo at:i put:p.
		rem accumulate: aPolynomial coefficient * p negated from: i
	].
	^Array with: (self class coefficient:quo) with: (self class coefficient: (rem copyLast: aPolynomial order))! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 18:27'!
roots

	^self laguerresRoots! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 15:39'!
subtractFromPolynomial: aPolynomial 

	| maxOrder |
	maxOrder := self order max: aPolynomial order.
	^self class coefficient: 
		((aPolynomial order: maxOrder) coefficient - (self order: maxOrder) coefficient)
! !

!Polynomial methodsFor: 'answering' stamp: 'HwaJong 8/29/2013 19:13'!
value: aNumericValue

	^coefficientVector inject: 0 into: [:sum :coeff| (sum * aNumericValue) + coeff ].! !

Algorithm subclass: #LaguerreAlgorithm
	instanceVariableNames: 'f ff fff x roots polynomial'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DaliotsLinearAlgebra'!

!LaguerreAlgorithm methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 19:11'!
basicStep

	"Private - Find one root"
	|g h n sqrtPart denom a|

	g := (ff value:x)/(f value:x).
	h := g squared - ((fff value:x)/(f value:x)).

	n := f order.
	sqrtPart := ((n-1)*(n*h-g squared))sqrt.
	(g + sqrtPart) magnitude > (g - sqrtPart) magnitude
		ifTrue: [denom := g + sqrtPart]
		ifFalse: [denom := g - sqrtPart].
	a := n / denom.
	x := x - a.
	^a! !

!LaguerreAlgorithm methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 19:11'!
okToTerminate

	^(f value:x)=0
! !

!LaguerreAlgorithm methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 19:11'!
okToTerminateFor: dx

	^dx = 0
! !

!LaguerreAlgorithm methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 19:11'!
polynomial: aPolynomial

	polynomial := aPolynomial! !

!LaguerreAlgorithm methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 19:11'!
reset

	super reset.
	f := polynomial.
	ff := f derivatived.
	fff := ff derivatived.
	x := 1.! !

!LaguerreAlgorithm methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 19:11'!
root

	^x! !

Algorithm subclass: #RootsOfPolynomialAlgorithm
	instanceVariableNames: 'roots polynomial oneRootAlgorithm targetNumberOfRoots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DaliotsLinearAlgebra'!

!RootsOfPolynomialAlgorithm methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 19:08'!
basicStep

	|root|
	oneRootAlgorithm polynomial: polynomial.
	oneRootAlgorithm reset.
	oneRootAlgorithm run.
	root := oneRootAlgorithm root.
	roots add: root.
	polynomial := polynomial quo: (Polynomial root: root).
	^roots! !

!RootsOfPolynomialAlgorithm methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 19:08'!
initialize

	super initialize! !

!RootsOfPolynomialAlgorithm methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 19:08'!
okToTerminateFor: anOrderedCollection 

	^anOrderedCollection size = targetNumberOfRoots! !

!RootsOfPolynomialAlgorithm methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 19:09'!
oneRootAlgorithm: anAlgorithm

	oneRootAlgorithm := anAlgorithm! !

!RootsOfPolynomialAlgorithm methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 19:09'!
polynomial: aPolynomial

	polynomial := aPolynomial! !

!RootsOfPolynomialAlgorithm methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 19:09'!
reset

	super reset.
	roots := OrderedCollection new.
	targetNumberOfRoots := polynomial order.! !

!RootsOfPolynomialAlgorithm methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 19:09'!
roots

	^roots
! !

TestCase subclass: #PolynomialTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DaliotsLinearAlgebra'!

!PolynomialTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 15:29'!
testAddToInteger

	| coeff |
	coeff := ((Polynomial coefficient: #(1 2 3 4)) addToInteger: 3) coefficient.

	self
		assert: (coeff at: 1) = 1;
		assert: (coeff at: 2) = 2;
		assert: (coeff at: 3) = 3;
		assert: (coeff at: 4) = 7
! !

!PolynomialTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 15:37'!
testMinus

	self
		assert: (Polynomial coefficient: #(2 1)) - (Polynomial coefficient: #(1 2 1)) = (Polynomial coefficient: #(-1 0 0));
		assert: 5 - (Polynomial coefficient: #(1 2 1)) = (Polynomial coefficient: #(-1 -2 4));
		assert: (Polynomial coefficient: #(1 2 1)) - 5.0 = (Polynomial coefficient: #(1 2 -4.0))! !

!PolynomialTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 16:57'!
testMultiply

	self assert: (Polynomial coefficient: #(1 -1)) * (Polynomial coefficient: #(2 1)) = (Polynomial coefficient: #(2 -1 -1))! !

!PolynomialTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 18:19'!
testMultiplyAndAddition

	self assert: 
		(Polynomial roots: #(1 1)) coefficient asArray = #(1 -2 1)! !

!PolynomialTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 18:21'!
testMultiplyByNumber

	| coeff |
	coeff := ((Polynomial coefficient: #(1 -2 1)) * 4) coefficient.

	self 
		assert: (coeff at: 1) = 4;
		assert: (coeff at: 2) = -8;
		assert: (coeff at: 3) = 4! !

!PolynomialTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 18:23'!
testPlus

	self
		assert: 
			(
				(Polynomial coefficient: #(1 2)) + 
				(Polynomial coefficient: #(2 -1))
			) = 
				(Polynomial coefficient: #(3 1));
		assert:
			(
				1.0 + 
				(Polynomial coefficient: #(2 -1))
			) = 
				(Polynomial coefficient: #(2 0));
		assert:
			(
				(Polynomial coefficient: #(2 -1))
				+
				1.0
			) = 
				(Polynomial coefficient: #(2 0))
! !

!PolynomialTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 18:26'!
testRootFinding

	self assert: ( (Polynomial roots: #(1 2 3)) roots includesAll: #(1 2 3) )! !
